import {
    Button, Modal, ModalService, Select, Tabs, TextInput, Text, LoadingService, Form, DialogService, Textarea, Footer,
} from '@zeedhi/common';
import { Utilities } from '@/util/Utilities';
import { Http, Metadata } from '@zeedhi/core';
import { TekGrid } from '@zeedhi/teknisa-components-common';

export class ProposalModelController {
    public tekgridProposalModelVisible: boolean = true;

    public currentRow: any = {};

    public currentRowViewSignatariosPadroes: any = {};

    public currentRowViewItens: any = {};

    private basicModal!: Modal;

    private ModalViewSignatariosPadroes!: Modal;

    private ModalViewItens!: Modal;

    get formProposalModelVisible() {
        return !this.tekgridProposalModelVisible;
    }

    public visibilityTabComp: boolean = true;

    public visibilityTabIt: boolean = true;

    get visibilityTabComposicoes() {
        return !this.visibilityTabComp;
    }

    get visibilityTabItens() {
        return !this.visibilityTabIt;
    }

    public visibilityUtilizaComposicao({ component }: any) {
        if (component.value === 'S') {
            this.visibilityTabComp = true;
            this.visibilityTabIt = false;
        } else {
            this.visibilityTabComp = false;
            this.visibilityTabIt = true;
        }
    }

    public changeFacilities({ component }: any) {
        const intlocal = Metadata.getInstance<Select>(`${component.name.split('_')[0]}_IDINTEGRALOCAISFM`);
        const intmed = Metadata.getInstance<Select>(`${component.name.split('_')[0]}_IDINTEGRAMEDICAOFM`);
        if (component.value === 'S') {
            intlocal.disabled = false;
            intmed.disabled = false;
        } else {
            intlocal.disabled = true;
            intmed.disabled = true;
            intlocal.value = null;
            intmed.value = null;
        }
    }

    public changeTecFood({ component }: any) {
        const tiposerv = Metadata.getInstance<Select>(`${component.name.split('_')[0]}_IDTIPOSERVINTTECFOOD`);

        if (component.value === 'S') {
            tiposerv.disabled = false;
        } else {
            tiposerv.disabled = true;
            tiposerv.value = null;
        }
    }
    
    public changeAssinatura({ component }: any) {
        const tipodoc = Metadata.getInstance<TextInput>(`${component.name.split('_')[0]}_NRTIPODOCCERTSIGN`);
        const enviarDoc = Metadata.getInstance<Select>(`${component.name.split('_')[0]}_IDENVIADOCOPERRESPCONCASS`);

        if (component.value === 'S') {
            tipodoc.disabled = false;
            enviarDoc.disabled = false;
        } else {
            tipodoc.disabled = true;
            enviarDoc.disabled = true;
            tipodoc.value = null;
            enviarDoc.value = null;
        }
    }

    public expandir({ component }: any) {
        const form = Metadata.getInstance<Form>(component.name.split('_')[1]);
        form.isVisible = !form.isVisible;

        component.iconName = (component.iconName === 'mdi-chevron-down') ? 'mdi-chevron-right' : 'mdi-chevron-down';
    }

    public backTekGridProposalModel() {
        this.tekgridProposalModelVisible = true;
    }

    get textFrameProposalModel() {
        return this.currentRow.NMORCAMENTOMODELO;
    }

    public openFrameProposalModel({ row }: any) {
        this.tekgridProposalModelVisible = false;
        this.currentRow = row;
        this.loadTabsProposalModel();
    }

    public loadTabsProposalModel() {
        const setOfTabs = Metadata.getInstance<Tabs>('tabsInformationProposalModel');
        const footer = Metadata.getInstance<Footer>('footer-proposal-model');

        if (setOfTabs.tabs[setOfTabs.activeTab].name === 'tab_proposalModelTab') {
            footer.isVisible = true;
            this.proposalModelTab();
        } else if (setOfTabs.tabs[setOfTabs.activeTab].name === 'tab_proposalModelTabEscopoFaturamento') {
            footer.isVisible = false;
            this.proposalModelTabEscopoFaturamento();
        } else if (setOfTabs.tabs[setOfTabs.activeTab].name === 'tab_proposalModelTabComposicoes') {
            footer.isVisible = false;
            this.proposalModelTabComposicoes();
        } else if (setOfTabs.tabs[setOfTabs.activeTab].name === 'tab_proposalModelTabItens') {
            footer.isVisible = false;
            this.proposalModelTabItens();
        } else if (setOfTabs.tabs[setOfTabs.activeTab].name === 'tab_proposalModelTabPerfisAcesso') {
            footer.isVisible = false;
            this.proposalModelTabPerfisAcesso();
        } else if (setOfTabs.tabs[setOfTabs.activeTab].name === 'tab_proposalModelTabSignatariosPadroes') {
            footer.isVisible = false;
            this.proposalModelTabSignatariosPadroes();
        }
    }

    public proposalModelTab() {
        Metadata.getInstance<Select>('proposalModelTab-IDATIVO').value = this.currentRow.IDATIVO;
        Metadata.getInstance<Select>('proposalModelTab-IDBLOQALTERADADOS').value = this.currentRow.IDBLOQALTERADADOS;
        Metadata.getInstance<TextInput>('proposalModelTab-NMORCAMENTOMODELO').value = this.currentRow.NMORCAMENTOMODELO;
        Metadata.getInstance<TextInput>('proposalModelTab-QTDIASVALIDADE').value = this.currentRow.QTDIASVALIDADE;
        Metadata.getInstance<TextInput>('proposalModelTab-QTDIASCONTRATO').value = this.currentRow.QTDIASCONTRATO;
        Metadata.getInstance<Select>('proposalModelTab-IDUTILIZACOMP').value = this.currentRow.IDUTILIZACOMP;
        Metadata.getInstance<TextInput>('proposalModelTab-NRDIASCARENCIA').value = this.currentRow.NRDIASCARENCIA;
        Metadata.getInstance<Select>('proposalModelTab-IDOBRIGAOPORTUNIDADE').value = this.currentRow.IDOBRIGAOPORTUNIDADE;
        Metadata.getInstance<TextInput>('proposalModelTab-NRSEQMODCONTRA').value = this.currentRow.NRSEQMODCONTRA;
        Metadata.getInstance<TextInput>('proposalModelTab-CDMINEMORCA').value = this.currentRow.CDMINEMORCA;
        Metadata.getInstance<Textarea>('proposalModelTab-DSREFERENCIAORCA').value = this.currentRow.DSREFERENCIAORCA;
        Metadata.getInstance<Textarea>('proposalModelTab-DSOBSERVACAOORCA').value = this.currentRow.DSOBSERVACAOORCA;
        Metadata.getInstance<Select>('proposalModelTab-IDASSELETRDIGITAL').value = this.currentRow.IDASSELETRDIGITAL;
        Metadata.getInstance<Select>('proposalModelTab-IDENVIADOCCONCLUSAO').value = this.currentRow.IDENVIADOCCONCLUSAO;
        Metadata.getInstance<Select>('proposalModelTab-NRTIPODOCCERTSIGN').value = this.currentRow.NRTIPODOCCERTSIGN;
        Metadata.getInstance<Select>('proposalModelTab-IDENVIADOCOPERRESPCONCASS').value = this.currentRow.IDENVIADOCOPERRESPCONCASS;
    }

    public proposalModelTabEscopoFaturamento() {
        try {
            const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-tab-escopo-faturamento-proposal');
            grid.datasource.setFilter({
                NRORCAMENTOMODELO: this.currentRow.NRORCAMENTOMODELO,
            });
        } catch (e) {
            // console.error(e);
        }
    }

    public proposalModelTabComposicoes() {
        try {
            const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-tab-composicoes');
            grid.datasource.setFilter({
                NRORCAMENTOMODELO: this.currentRow.NRORCAMENTOMODELO,
            });
        } catch (e) {
            // console.error(e);
        }
    }

    public proposalModelTabItens() {
        try {
            const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-tab-itens-proposal');
            grid.datasource.setFilter({
                NRORCAMENTOMODELO: this.currentRow.NRORCAMENTOMODELO,
            });
        } catch (e) {
            // console.error(e);
        }
    }

    public proposalModelTabPerfisAcesso() {
        try {
            const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-tab-perfis-acesso-proposal');
            grid.datasource.setFilter({
                NRORCAMENTOMODELO: this.currentRow.NRORCAMENTOMODELO,
            });
        } catch (e) {
            // console.error(e);
        }
    }

    public proposalModelTabSignatariosPadroes() {
        try {
            const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-tab-signatarios-padroes-proposal');
            grid.datasource.setFilter({
                NRORCAMENTOMODELO: this.currentRow.NRORCAMENTOMODELO,
            });
        } catch (e) {
            // console.error(e);
        }
    }

    public editProposalModel() {
        const formDadosProposalModelEditDadosModelo = Metadata.getInstance<Form>('proposalModelTab-formRowDadosModelo');
        // const formDadosProposalModelAddIntegracao = Metadata.getInstance<Form>('formIntegracaoFacilities');
        // const formProposalModelDigital = Metadata.getInstance<Form>('formAssEletronica');
        // const formTecFood = Metadata.getInstance<Form>('formIntegraTecFood');
        const grid = Metadata.getInstance<TekGrid>('tek-grid-proposal-model_grid');
        const params = {
            NRORCAMENTOMODELO: this.currentRow.NRORCAMENTOMODELO,
            IDATIVO: Metadata.getInstance<Select>('proposalModelTab-IDATIVO').value,
            IDBLOQALTERADADOS: Metadata.getInstance<Select>('proposalModelTab-IDBLOQALTERADADOS').value,
            NMORCAMENTOMODELO: Metadata.getInstance<Select>('proposalModelTab-NMORCAMENTOMODELO').value,
            QTDIASVALIDADE: Metadata.getInstance<Select>('proposalModelTab-QTDIASVALIDADE').value,
            QTDIASCONTRATO: Metadata.getInstance<Select>('proposalModelTab-QTDIASCONTRATO').value,
            IDUTILIZACOMP: Metadata.getInstance<Select>('proposalModelTab-IDUTILIZACOMP').value,
            NRDIASCARENCIA: Metadata.getInstance<Select>('proposalModelTab-NRDIASCARENCIA').value,
            IDOBRIGAOPORTUNIDADE: Metadata.getInstance<Select>('proposalModelTab-IDOBRIGAOPORTUNIDADE').value,
            NRSEQMODCONTRA: Metadata.getInstance<Select>('proposalModelTab-NRSEQMODCONTRA').value,
            CDMINEMORCA: Metadata.getInstance<Select>('proposalModelTab-CDMINEMORCA').value,
            DSREFERENCIAORCA: Metadata.getInstance<Select>('proposalModelTab-DSREFERENCIAORCA').value,
            DSOBSERVACAOORCA: Metadata.getInstance<Select>('proposalModelTab-DSOBSERVACAOORCA').value,
            IDASSELETRDIGITAL: Metadata.getInstance<Select>('proposalModelTab-IDASSELETRDIGITAL').value,
            IDENVIADOCCONCLUSAO: Metadata.getInstance<Select>('proposalModelTab-IDENVIADOCCONCLUSAO').value,
            NRTIPODOCCERTSIGN: Metadata.getInstance<Select>('proposalModelTab-NRTIPODOCCERTSIGN').value,
            IDENVIADOCOPERRESPCONCASS: Metadata.getInstance<Select>('proposalModelTab-IDENVIADOCOPERRESPCONCASS').value,
        };

        if (Utilities.validateForm(formDadosProposalModelEditDadosModelo)) {
            LoadingService.show();
            Http.post('/editProposalModel', params).then(() => {
                grid.datasource.get();
                this.backTekGridProposalModel();
                Utilities.showSuccessMessage();
            }).catch((error: any) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                LoadingService.hide();
            });
        }
    }

    public editProposalModelViewItens() {
        const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-tab-signatarios-padroes');

        if (Utilities.validateGrid(grid)) {
            LoadingService.show();
            const EDITEDROWS = {
                // NRSEQMODCONTRA: this.currentRow.NRSEQMODCONTRA,
                // NRSIGNATPADRCONT: Metadata.getInstance<Select>('formDadosProposalModelViewSignatariosPadroes-NRSIGNATPADRCONT').value,
                // IDTPSIGNATARIO: Metadata.getInstance<Select>('formDadosProposalModelViewSignatariosPadroes-IDTPSIGNATARIO').value,
                // NRPARCNEGOCIO: Metadata.getInstance<Select>('formDadosProposalModelViewSignatariosPadroes-NRPARCNEGOCIO').value,
                // IDTIPOASSINATURA: Metadata.getInstance<Select>('formDadosProposalModelViewSignatariosPadroes-IDTIPOASSINATURA').value,
                // IDTESTEMUNHA: Metadata.getInstance<Select>('formDadosProposalModelViewSignatariosPadroes-IDTESTEMUNHA').value,
                // NRORDENACAO: Metadata.getInstance<Select>('formDadosProposalModelViewSignatariosPadroes-NRORDENACAO').value,
                // DSEMAILNOTSIGNENV: Metadata.getInstance<Select>('formDadosProposalModelViewSignatariosPadroes-DSEMAILNOTSIGNENV').value,
                // DSEMAILNOTIFOUTROS: Metadata.getInstance<Select>('formDadosProposalModelViewSignatariosPadroes-DSEMAILNOTIFOUTROS').value,
                // CDOPERADOR: Metadata.getInstance<Select>('formDadosProposalModelViewSignatariosPadroes-CDOPERADOR').value,
            };
            Http.post('/editProposalModelViewItens', EDITEDROWS).then(() => {
                this.closeViewSignatariosPadroes();
                grid.datasource.get();
                Utilities.showSuccessMessage();
            }).catch((error: any) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                LoadingService.hide();
            });
        }
    }

    public editProposalModelTabSignatariosPadroes() {
        const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-tab-signatarios-padroes');

        if (Utilities.validateGrid(grid)) {
            LoadingService.show();
            const EDITEDROWS = {
                NRSEQMODCONTRA: this.currentRow.NRSEQMODCONTRA,
                NRSIGNATPADRCONT: Metadata.getInstance<Select>('formDadosProposalModelViewSignatariosPadroes-NRSIGNATPADRCONT').value,
                IDTPSIGNATARIO: Metadata.getInstance<Select>('formDadosProposalModelViewSignatariosPadroes-IDTPSIGNATARIO').value,
                NRPARCNEGOCIO: Metadata.getInstance<Select>('formDadosProposalModelViewSignatariosPadroes-NRPARCNEGOCIO').value,
                IDTIPOASSINATURA: Metadata.getInstance<Select>('formDadosProposalModelViewSignatariosPadroes-IDTIPOASSINATURA').value,
                IDTESTEMUNHA: Metadata.getInstance<Select>('formDadosProposalModelViewSignatariosPadroes-IDTESTEMUNHA').value,
                NRORDENACAO: Metadata.getInstance<Select>('formDadosProposalModelViewSignatariosPadroes-NRORDENACAO').value,
                DSEMAILNOTSIGNENV: Metadata.getInstance<Select>('formDadosProposalModelViewSignatariosPadroes-DSEMAILNOTSIGNENV').value,
                DSEMAILNOTIFOUTROS: Metadata.getInstance<Select>('formDadosProposalModelViewSignatariosPadroes-DSEMAILNOTIFOUTROS').value,
                CDOPERADOR: Metadata.getInstance<Select>('formDadosProposalModelViewSignatariosPadroes-CDOPERADOR').value,
            };
            Http.post('/editProposalModelTabSignatariosPadroes', EDITEDROWS).then(() => {
                this.closeViewSignatariosPadroes();
                grid.datasource.get();
                Utilities.showSuccessMessage();
            }).catch((error: any) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                LoadingService.hide();
            });
        }
    }

    public openFilterProposalModel({ component }: any) {
        const filterButton = Metadata.getInstance<Button>(`${component.name}_filterButton`);
        filterButton.click({} as Event, {} as HTMLElement);
    }

    public closeModalAddProposalModel() {
        this.basicModal.hide();
        this.basicModal?.destroy();
    }

    public async openModalAddProposalModel() {
        await this.showModalAddProposalModel();
        Metadata.getInstance<Text>('titleText').text = 'Novo Modelo de Proposta';
    }

    public async openModalProposalModelAddTabEscopoFaturamento() {
        await this.showModalProposalModelAddTabEscopoFaturamento();
        Metadata.getInstance<Text>('titleText').text = 'Novo Escopo de Faturamento';
    }

    public async openModalProposalModelAddTabComposicoes() {
        await this.showModalProposalModelAddTabComposicoes();
        Metadata.getInstance<Text>('titleText').text = 'Nova Composição de Serviços';
    }

    public async openModalProposalModelAddTabItens() {
        await this.showModalProposalModelAddTabItens();
        Metadata.getInstance<Text>('titleText').text = 'Novo Item';
    }

    public async openModalProposalModelAddTabPerfisAcesso() {
        await this.showModalProposalModelAddTabPerfisAcesso();
        Metadata.getInstance<Text>('titleText').text = 'Novo Perfil de Acesso';
    }

    public async openModalProposalModelAddTabSignatariosPadroes() {
        await this.showModalProposalModelAddTabSignatariosPadroes();
        Metadata.getInstance<Text>('titleText').text = 'Novo Signatário Padrão';
    }

    public async showModalAddProposalModel() {
        this.basicModal = await ModalService.createFromJson('proposalModel/modal/proposalModelAdd', true);
        this.basicModal.show();
    }

    public async showModalProposalModelAddTabEscopoFaturamento() {
        this.basicModal = await ModalService.createFromJson('proposalModel/modal/proposalModelAddTabEscopoFaturamento', true);
        this.basicModal.show();
    }

    public async showModalProposalModelAddTabComposicoes() {
        this.basicModal = await ModalService.createFromJson('proposalModel/modal/proposalModelAddTabComposicoes', true);
        this.basicModal.show();
    }

    public async showModalProposalModelAddTabItens() {
        this.basicModal = await ModalService.createFromJson('proposalModel/modal/proposalModelAddTabItens', true);
        this.basicModal.show();
    }

    public async showModalProposalModelAddTabPerfisAcesso() {
        this.basicModal = await ModalService.createFromJson('proposalModel/modal/proposalModelAddTabPerfisAcesso', true);
        this.basicModal.show();
    }

    public async showModalProposalModelAddTabSignatariosPadroes() {
        this.basicModal = await ModalService.createFromJson('proposalModel/modal/proposalModelAddTabSignatariosPadroes', true);
        this.basicModal.show();
    }

    public saveModalAddProposalModel() {
        const formDadosProposalModelAddDadosModelo = Metadata.getInstance<Form>('formDadosProposalModelAddDadosModelo');
        const formDadosProposalModelFacilities = Metadata.getInstance<Form>('formDadosProposalModelFacilities');
        const formDadosProposalModelDigital = Metadata.getInstance<Form>('formDadosProposalModelDigital');
        const grid = Metadata.getInstance<TekGrid>('tek-grid-proposal-model_grid');
        const params = {
            NMMODCONTRATO: Metadata.getInstance<Select>('formDadosProposalModelAddDadosModelo-NMMODCONTRATO').value,
            IDATIVO: Metadata.getInstance<Select>('formDadosProposalModelAddDadosModelo-IDATIVO').value,
            CDMODCONTRATO: Metadata.getInstance<Select>('formDadosProposalModel-CDMODCONTRATO').value,
            IDGERAPROPOSTA: Metadata.getInstance<Select>('formDadosProposalModel-IDGERAPROPOSTA').value,
            CDCENTCUST: Metadata.getInstance<Select>('formDadosProposalModel-CDCENTCUST').value,
            NRDIASVIGCONT: Metadata.getInstance<Select>('formDadosProposalModel-NRDIASVIGCONT').value,
            IDRENOVACAOAUTOMATICA: Metadata.getInstance<Select>('formDadosProposalModel-IDRENOVACAOAUTOMATICA').value,
            NRDIASPRORGCONT: Metadata.getInstance<Select>('formDadosProposalModel-NRDIASPRORGCONT').value,
            IDBLOQALTDTINICONTRENEG: Metadata.getInstance<Select>('formDadosProposalModel-IDBLOQALTDTINICONTRENEG').value,
            IDREAJUSTEAUTOMATICO: Metadata.getInstance<Select>('formDadosProposalModel-IDREAJUSTEAUTOMATICO').value,
            NRDIASREAJAUTOMATICO: Metadata.getInstance<Select>('formDadosProposalModel-NRDIASREAJAUTOMATICO').value,
            IDINTEGRACAOFM: Metadata.getInstance<Select>('formDadosProposalModelFacilities_IDINTEGRACAOFM').value,
            IDINTEGRALOCAISFM: Metadata.getInstance<Select>('formDadosProposalModelFacilities_IDINTEGRALOCAISFM').value,
            IDINTEGRAMEDICAOFM: Metadata.getInstance<Select>('formDadosProposalModelFacilities_IDINTEGRAMEDICAOFM').value,
            IDASSELETRDIGITAL: Metadata.getInstance<Select>('formDadosProposalModelDigital_IDASSELETRDIGITAL').value,
            NRTIPODOCCERTSIGN: Metadata.getInstance<Select>('formDadosProposalModelDigital_NRTIPODOCCERTSIGN').value,
            IDENVIADOCOPERRESPCONCASS: Metadata.getInstance<Select>('formDadosProposalModelDigital_IDENVIADOCOPERRESPCONCASS').value,
            IDINTEGRACAOTECFOOD: Metadata.getInstance<Select>('formIntegracaoTecFood_IDINTEGRACAOTECFOOD').value,
            IDTIPOSERVINTTECFOOD: Metadata.getInstance<Select>('formIntegracaoTecFood_IDTIPOSERVINTTECFOOD').value,
        };
        if (Utilities.validateForm(formDadosProposalModelAddDadosModelo) && Utilities.validateForm(formDadosProposalModelFacilities) && Utilities.validateForm(formDadosProposalModelDigital)) {
            LoadingService.show();
            Http.post('/saveModalAddProposalModel', params).then(() => {
                this.closeModalAddProposalModel();
                grid.datasource.get();
                Utilities.showSuccessMessage();
            }).catch((error: any) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                LoadingService.hide();
            });
        }
    }

    public showConfirmDeleteMessage({ event }: any) {
        Utilities.showConfirmDeleteMessage(event, 'ProposalModelController.deleteProposalModel');
    }

    public deleteProposalModel() {
        const grid = Metadata.getInstance<TekGrid>('tek-grid-proposal-model_grid');
        LoadingService.show();
        Http.post('/deleteProposalModel', {
            NRS: grid.selectedRows.map((element: any) => element.NRSEQMODCONTRA),
        }).then(() => {
            grid.selectedRows = [];
            grid.reload();
            Utilities.showSuccessMessage();
        }).catch((error) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
        });
    }

    public saveModalAddProposalModelTabEscopoFaturamento() {
        const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-tab-escopo-faturamento-proposal');
        const params = {
            NRORCAMENTOMODELO: this.currentRow.NRORCAMENTOMODELO,
            NRTIPOORCAMENTO: Metadata.getInstance<Select>('getEscopoDeFaturamento-NRTIPOORCAMENTO').value,
        };

        LoadingService.show();
        Http.post('/saveModalAddProposalModelTabEscopoFaturamento', params).then(() => {
            this.closeModalAddProposalModel();
            grid.datasource.get();
            Utilities.showSuccessMessage();
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
        });
    }

    public saveModalAddProposalModelTabComposicoes() {
        const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-tab-composicoes');
        const params = {
            NRORCAMENTOMODELO: this.currentRow.NRORCAMENTOMODELO,
            NRCOMPSERVICO: Metadata.getInstance<Select>('formDadosProposalModel-NRCOMPSERVICO').value,
        };

        LoadingService.show();
        Http.post('/saveModalAddProposalModelTabComposicoes', params).then(() => {
            this.closeModalAddProposalModel();
            grid.datasource.get();
            Utilities.showSuccessMessage();
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
        });
    }

    public saveModalAddProposalModelTabPerfisAcesso() {
        const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-tab-perfis-acesso-proposal');
        const params = {
            NRORCAMENTOMODELO: this.currentRow.NRORCAMENTOMODELO,
            NRPERFILACESSO: Metadata.getInstance<Select>('formDadosProposalModel-NRPERFILACESSO').value,
        };

        LoadingService.show();
        Http.post('/saveModalAddProposalModelTabPerfisAcesso', params).then(() => {
            this.closeModalAddProposalModel();
            grid.datasource.get();
            Utilities.showSuccessMessage();
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
        });
    }

    public saveModalAddProposalModelTabSignatariosPadroes() {
        const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-tab-signatarios-padroes-proposal');
        const form = Metadata.getInstance<Form>('formDadosProposalModelAddTabSignatariosPadroes');
        if (Utilities.validateForm(form)) {
            const params = {
                NRSEQMODCONTRA: this.currentRow.NRSEQMODCONTRA,
                IDTPSIGNATARIO: Metadata.getInstance<Select>('formDadosProposalModelAddTabSignatariosPadroes-IDTPSIGNATARIO').value,
                NRPARCNEGOCIO: Metadata.getInstance<Select>('formDadosProposalModelAddTabSignatariosPadroes-NRPARCNEGOCIO').value,
                IDTIPOASSINATURA: Metadata.getInstance<Select>('formDadosProposalModelAddTabSignatariosPadroes-IDTIPOASSINATURA').value,
                IDTESTEMUNHA: Metadata.getInstance<Select>('formDadosProposalModelAddTabSignatariosPadroes-IDTESTEMUNHA').value,
                NRORDENACAO: Metadata.getInstance<Select>('formDadosProposalModelAddTabSignatariosPadroes-NRORDENACAO').value,
                DSEMAILNOTSIGNENV: Metadata.getInstance<Select>('formDadosProposalModelAddTabSignatariosPadroes-DSEMAILNOTSIGNENV').value,
                CDOPERADOR: Metadata.getInstance<Select>('formDadosProposalModelAddTabSignatariosPadroes-CDOPERADOR').value,
                DSEMAILNOTIFOUTROS: Metadata.getInstance<Select>('formDadosProposalModelAddTabSignatariosPadroes-DSEMAILNOTIFOUTROS').value,
            };

            LoadingService.show();
            Http.post('/saveModalAddProposalModelTabSignatariosPadroes', params).then(() => {
                this.closeModalAddProposalModel();
                grid.datasource.get();
                Utilities.showSuccessMessage();
            }).catch((error: any) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                LoadingService.hide();
            });
        }
    }

    public showConfirmDeleteMessageTabComposicoes({ event }: any) {
        Utilities.showConfirmDeleteMessage(event, 'ProposalModelController.deleteProposalModelTabComposicoes');
    }

    public deleteProposalModelTabComposicoes() {
        const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-tab-composicoes');
        LoadingService.show();
        Http.post('/deleteProposalModelTabComposicoes', {
            NRS: grid.selectedRows.map((element: any) => element.NRRELORCAMODCOMP),
        }).then(() => {
            grid.selectedRows = [];
            grid.reload();
            Utilities.showSuccessMessage();
        }).catch((error) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
            DialogService.hide();
        });
    }

    public showConfirmDeleteMessageTabPerfisAcesso({ event }: any) {
        Utilities.showConfirmDeleteMessage(event, 'ProposalModelController.deleteProposalModelTabPerfisAcesso');
    }

    public deleteProposalModelTabPerfisAcesso() {
        const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-tab-perfis-acesso-proposal');
        LoadingService.show();
        Http.post('/deleteProposalModelTabPerfisAcesso', {
            NRS: grid.selectedRows.map((element: any) => element.NRRELORCAMODPERFACESS),
        }).then(() => {
            grid.selectedRows = [];
            grid.reload();
            Utilities.showSuccessMessage();
        }).catch((error) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
            DialogService.hide();
        });
    }

    public showConfirmDeleteMessageTabSignatariosPadroes({ event }: any) {
        Utilities.showConfirmDeleteMessage(event, 'ProposalModelController.deleteProposalModelTabSignatariosPadroes');
    }

    public deleteProposalModelTabSignatariosPadroes() {
        const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-tab-signatarios-padroes');
        LoadingService.show();
        Http.post('/deleteProposalModelTabSignatariosPadroes', {
            NRSIGNATPADRCONT: grid.selectedRows.map((element: any) => element.NRSIGNATPADRCONT),
            NRORCAMENTOMODELO: this.currentRow.NRORCAMENTOMODELO,
        }).then(() => {
            grid.selectedRows = [];
            grid.reload();
            Utilities.showSuccessMessage();
        }).catch((error) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
            DialogService.hide();
        });
    }

    public showConfirmDeleteMessageTabEscopoFaturamento({ event }: any) {
        Utilities.showConfirmDeleteMessage(event, 'ProposalModelController.deleteProposalModelTabEscopoFaturamento');
    }

    public deleteProposalModelTabEscopoFaturamento() {
        const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-tab-escopo-faturamento-proposal');
        LoadingService.show();
        Http.post('/deleteProposalModelTabEscopoFaturamento', {
            NRS: grid.selectedRows.map((element: any) => element.NRRELACESCOPOMODELO),
        }).then(() => {
            grid.selectedRows = [];
            grid.reload();
            Utilities.showSuccessMessage();
        }).catch((error) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
            DialogService.hide();
        });
    }

    public async createViewItens() {
        this.ModalViewItens = await ModalService.createFromJson('/proposalModel/modal/proposalModelViewItens', true);
        await this.ModalViewItens.hide();
    }

    public closeViewItens() {
        this.ModalViewItens.hide();
    }

    public preencheViewItens({ row }: any) {
        this.currentRowViewItens = row;
        console.warn(this.currentRowViewItens);
        this.ModalViewItens.show();
        this.loadTabsProposalModel();
        Metadata.getInstance<Select>('formDadosProposalModelViewItens-IDITEMESPELHO').value = this.currentRowViewItens.IDITEMESPELHO;
        Metadata.getInstance<Select>('formDadosProposalModelViewItens-NMITEMORCAMENTO').value = this.currentRowViewItens.CODIGO;
        Metadata.getInstance<Select>('formDadosProposalModelViewItens-QTITEMORCAMENTO').value = this.currentRowViewItens.QTITEMORCAMENTO;
        Metadata.getInstance<Select>('formDadosProposalModelViewItens-IDMULTMEDVRTOT').value = this.currentRowViewItens.IDMULTMEDVRTOT;
        Metadata.getInstance<Select>('formDadosProposalModelViewItens-CDTPMEDIDASERV').value = this.currentRowViewItens.CDTPMEDIDASERV;
        Metadata.getInstance<Select>('formDadosProposalModelViewItens-QTMEDIDAORCA').value = this.currentRowViewItens.QTMEDIDAORCA;
        Metadata.getInstance<Select>('formDadosProposalModelViewItens-VRUNITITEMORCA').value = this.currentRowViewItens.VRUNITITEMORCA;
        Metadata.getInstance<Select>('formDadosProposalModelViewItens-VRTOTALITEMORCA').value = this.currentRowViewItens.VRTOTALITEMORCA;
        Metadata.getInstance<Select>('formDadosProposalModelViewItens-IDITEMOBRIGORCA').value = this.currentRowViewItens.IDITEMOBRIGORCA;
        Metadata.getInstance<Select>('formDadosProposalModelViewItens-IDBLOQALTORC').value = this.currentRowViewItens.IDBLOQALTORC;
        Metadata.getInstance<Select>('formDadosProposalModelViewItens-IDIMPRESSAOORCA').value = this.currentRowViewItens.IDIMPRESSAOORCA;
    }

    public changeUtilizaTipoMedida() {
        const UTILIZATIPOMEDIDA = Metadata.getInstance<Select>('formDadosProposalModelViewItens-IDMULTMEDVRTOT').value;
        const TIPOMEDIDA = Metadata.getInstance<Select>('formDadosProposalModelViewItens-CDTPMEDIDASERV');
        const QUANTIDADEMEDIDA = Metadata.getInstance<Select>('formDadosProposalModelViewItens-QTMEDIDAORCA');

        if (UTILIZATIPOMEDIDA === 'S') {
            TIPOMEDIDA.readonly = false;
            TIPOMEDIDA.addValidation('required', {});
            QUANTIDADEMEDIDA.readonly = false;
            QUANTIDADEMEDIDA.addValidation('required', {});
        } else {
            TIPOMEDIDA.readonly = true;
            TIPOMEDIDA.removeValidation('required');
            QUANTIDADEMEDIDA.readonly = true;
            QUANTIDADEMEDIDA.removeValidation('required');
        }
    }

    public changeTipoSignatario() {
        const tipoSignatario = Metadata.getInstance<Select>('formDadosProposalModelAddTabSignatariosPadroes-IDTPSIGNATARIO').value;
        const SIGNATARIO = Metadata.getInstance<Select>('formDadosProposalModelAddTabSignatariosPadroes-NRPARCNEGOCIO');
        const TIPOASSINATURA = Metadata.getInstance<Select>('formDadosProposalModelAddTabSignatariosPadroes-IDTIPOASSINATURA');
        const TESTEMUNHA = Metadata.getInstance<Select>('formDadosProposalModelAddTabSignatariosPadroes-IDTESTEMUNHA');
        const CPF = Metadata.getInstance<Select>('formDadosProposalModelAddTabSignatariosPadroes-CPF');

        if (tipoSignatario === 'SE') {
            SIGNATARIO.readonly = false;
            SIGNATARIO.addValidation('required', {});
            TIPOASSINATURA.readonly = false;
            TESTEMUNHA.readonly = false;
        } else {
            SIGNATARIO.readonly = true;
            SIGNATARIO.removeValidation('required');
            TIPOASSINATURA.readonly = true;
            TESTEMUNHA.readonly = true;

            SIGNATARIO.value = '';
            CPF.value = '';
        }
    }

    public preencheCpfSignatario() {
        const SIGNATARIO = Metadata.getInstance<Select>('formDadosProposalModelAddTabSignatariosPadroes-NRPARCNEGOCIO').value;
        const CPF = Metadata.getInstance<Select>('formDadosProposalModelAddTabSignatariosPadroes-CPF');
        CPF.value = '';
        LoadingService.show();
        Http.post('/getCpfSignatario', { signatario: SIGNATARIO }).then((response) => {
            CPF.value = response.data[0].NRINSCRICAOPARC;
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
        });
    }

    public preencheCpfViewSignatario() {
        const SIGNATARIO = Metadata.getInstance<Select>('formDadosProposalModelViewSignatariosPadroes-NRPARCNEGOCIO').value;
        const CPF = Metadata.getInstance<Select>('formDadosProposalModelViewSignatariosPadroes-CPF');
        CPF.value = '';
        LoadingService.show();
        Http.post('/getCpfSignatario', { signatario: SIGNATARIO }).then((response) => {
            CPF.value = response.data[0].NRINSCRICAOPARC;
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
        });
    }

    public async createViewSignatariosPadroes() {
        this.ModalViewSignatariosPadroes = await ModalService.createFromJson('/proposalModel/modal/proposalModelViewSignatariosPadroes', true);
        this.ModalViewSignatariosPadroes.hide();
    }

    public openViewSignatariosPadroes({ row }: any) {
        this.currentRowViewSignatariosPadroes = row;
        if (!Array.isArray(this.currentRowViewSignatariosPadroes.CDOPERADOR)) {
            this.currentRowViewSignatariosPadroes.CDOPERADOR = this.currentRowViewSignatariosPadroes.CDOPERADOR.split(',');
        }
        if (!Array.isArray(this.currentRowViewSignatariosPadroes.DSEMAILNOTSIGNENV)) {
            this.currentRowViewSignatariosPadroes.DSEMAILNOTSIGNENV = this.currentRowViewSignatariosPadroes.DSEMAILNOTSIGNENV.split('_');
        }
        this.ModalViewSignatariosPadroes.show();
    }

    public closeViewSignatariosPadroes() {
        this.ModalViewSignatariosPadroes.hide();
    }

    public preencheViewSignatariosPadroes() {
        Metadata.getInstance<Select>('formDadosProposalModelViewSignatariosPadroes-NRSIGNATPADRCONT').value = this.currentRowViewSignatariosPadroes.NRSIGNATPADRCONT;
        Metadata.getInstance<Select>('formDadosProposalModelViewSignatariosPadroes-IDTPSIGNATARIO').value = this.currentRowViewSignatariosPadroes.IDTPSIGNATARIO;
        Metadata.getInstance<Select>('formDadosProposalModelViewSignatariosPadroes-NRPARCNEGOCIO').value = this.currentRowViewSignatariosPadroes.NRPARCNEGOCIO;
        Metadata.getInstance<Select>('formDadosProposalModelViewSignatariosPadroes-IDTIPOASSINATURA').value = this.currentRowViewSignatariosPadroes.IDTIPOASSINATURA;
        Metadata.getInstance<Select>('formDadosProposalModelViewSignatariosPadroes-IDTESTEMUNHA').value = this.currentRowViewSignatariosPadroes.IDTESTEMUNHA;
        Metadata.getInstance<Select>('formDadosProposalModelViewSignatariosPadroes-NRORDENACAO').value = this.currentRowViewSignatariosPadroes.NRORDENACAO;
        Metadata.getInstance<Select>('formDadosProposalModelViewSignatariosPadroes-DSEMAILNOTSIGNENV').value = this.currentRowViewSignatariosPadroes.DSEMAILNOTSIGNENV;
        Metadata.getInstance<Select>('formDadosProposalModelViewSignatariosPadroes-CDOPERADOR').value = this.currentRowViewSignatariosPadroes.CDOPERADOR;
        Metadata.getInstance<Select>('formDadosProposalModelViewSignatariosPadroes-DSEMAILNOTIFOUTROS').value = this.currentRowViewSignatariosPadroes.DSEMAILNOTIFOUTROS;
    }
}
