/* eslint-disable */
import {
    Metadata,
} from '@zeedhi/core';
import {
    Button, ModalService, Modal, Form, TextInput, Date, LoadingService,
} from '@zeedhi/common';

export class Sm00001002PropostaHistoricoController {
    private basicModal!: Modal;

    public textModal: string = '';

    public openFilter({ component }: any) {
        const filterButton = Metadata.getInstance<Button>(`${component.name}_filterButton`);
        filterButton.click({} as Event, {} as HTMLElement);
    }

    public async exibirModal() {
        this.basicModal = await ModalService.createFromJson('sm_00001_002_proposta_historico/modal/sm_00001_002_proposta_historico_modal', true);
    }

    public async abrirModal({ row }: any) {
        await this.basicModal.show();
        this.textModal = `Detalhes da Proposta: ${row.NRORCAMENTO}`;
        Metadata.getInstance<TextInput>('NRORCAMENTO').value = row.NRORCAMENTO;
        Metadata.getInstance<TextInput>('IDSITUACAOORCAMENTO').value = row.IDSITUACAOORCAMENTO;
        Metadata.getInstance<Date>('DTREFORCAMENTO').value = row.DTREFORCAMENTO;
        Metadata.getInstance<Date>('DTACEITEORCA').value = row.DTACEITEORCA;
        Metadata.getInstance<TextInput>('NMORCAMENTOMODELO').value = row.NMORCAMENTOMODELO;
        Metadata.getInstance<TextInput>('NMOPERRESPONSAVEL').value = row.NMOPERRESPONSAVEL;
        Metadata.getInstance<TextInput>('DSREFERENCIAORCA').value = row.DSREFERENCIAORCA;
        Metadata.getInstance<TextInput>('NMPRINCIPALPARC').value = row.NMPRINCIPALPARC;
        Metadata.getInstance<TextInput>('NMITEMORCAMENTO').value = row.NMITEMORCAMENTO;
        Metadata.getInstance<TextInput>('DSCAMPOALTERADO').value = row.DSCAMPOALTERADO;
        Metadata.getInstance<TextInput>('DSVALORANTIGO').value = row.DSVALORANTIGO;
        Metadata.getInstance<TextInput>('DSVALORNOVO').value = row.DSVALORNOVO;
        Metadata.getInstance<Date>('DTALTERACAO').value = row.DTALTERACAO;
        Metadata.getInstance<TextInput>('NMOPERALTERACAO').value = row.NMOPERALTERACAO;
    }

    public fecharModal() {
        this.basicModal.hide();
    }

    public expandir({ component }: any) {
        const form = Metadata.getInstance<Form>(component.name.split('_')[1]);
        form.isVisible = !form.isVisible;
        component.iconName = (component.iconName === 'mdi-chevron-down') ? 'mdi-chevron-right' : 'mdi-chevron-down';
    }
}
